module Gdas
  class AwsIamCredentials

    # @return [String, nil] AWS access key ID (`ASIA...` string).
    attr_reader :access_key

    # @return [String, nil] AWS secret access key (opaque bytes)
    attr_reader :secret_key

    # @return [String, nil] AWS session token (opaque bytes)
    attr_reader :session_token

    def initialize
      refresh_credentials
    end

    def refresh_credentials
      client = ::Aws::STS::Client.new(region: ENV['AWS_REGION'])
      credentials = client.config.credentials.credentials

      @access_key = credentials.access_key_id
      @secret_key = credentials.secret_access_key
      @session_token = credentials.session_token
    end
  end
end
