require 'active_support/string_inquirer'

module Gdas
  module Context
    class Runtime
      extend ::Memoist

      # Returns the current environment.
      #
      #   runtime.env # => "development"
      #   runtime.env.development? # => true
      #   runtime.env.production? # => false
      def env
        ::ActiveSupport::StringInquirer.new(ENV['RACK_ENV'])
      end

      memoize :env

      def sandbox?
        development? && ENV['SANDBOX'].to_i == 1
      end

      memoize :sandbox?

      def development?
        env.development?
      end

      memoize :development?

      def production?
        env.production?
      end

      memoize :production?

      def test?
        env.test?
      end

      memoize :test?

      def disable_s3?
        ENV['DISABLE_S3'] == '1'
      end

      memoize :disable_s3?
    end
  end
end
