module Gdas::JobMgmt
  class  ConfigurableReschedule < SidekiqUniqueJobs::OnConflict::Reschedule
    # This class monkey-patches the class in cht-framework-cp to support 7.1.30.
    # We should upgrade all services to use the new gem and then update
    # cht-framework-cp.

    def delay
      ENV['RESCHEDULE_DELAY_SEC'] || 5
    end

    # Create a new job from the current one.
    #   This will mess up sidekiq stats becaus a new job is created
    def call
      # support for custom perform_in with a specified queue
      if job_class.respond_to?('perform_with_queue_in')
        queue="default"  #sidekiq default
        item["args"].each do |arg|
          if arg.kind_of?(Array) and arg.first["queue"]
            queue = arg.first["queue"]
          elsif arg.kind_of?(Hash) and arg["queue"]
            queue=arg["queue"]
          end
        end
        job_class&.perform_with_queue_in(queue, delay, *item["args"])
      else
        job_class&.perform_in(delay, *item["args"]) if sidekiq_worker_class?
      end
    end
  end
end
